package inua.dwarf;

public class DW
{
  public static class TAG
  {
    static public final int array_type = 0x01;
    static public final int class_type = 0x02;
    static public final int entry_point = 0x03;
    static public final int enumeration_type = 0x04;
    static public final int formal_parameter = 0x05;
    static public final int imported_declaration = 0x08;
    static public final int label = 0x0a;
    static public final int lexical_block = 0x0b;
    static public final int member = 0x0d;
    static public final int pointer_type = 0x0f;
    static public final int reference_type = 0x10;
    static public final int compile_unit = 0x11;
    static public final int string_type = 0x12;
    static public final int structure_type = 0x13;
    static public final int subroutine_type = 0x15;
    static public final int typedef = 0x16;
    static public final int union_type = 0x17;
    static public final int unspecified_parameters = 0x18;
    static public final int variant = 0x19;
    static public final int common_block = 0x1a;
    static public final int common_inclusion = 0x1b;
    static public final int inheritance = 0x1c;
    static public final int inlined_subroutine = 0x1d;
    static public final int module = 0x1e;
    static public final int ptr_to_member_type = 0x1f;
    static public final int set_type = 0x20;
    static public final int subrange_type = 0x21;
    static public final int with_stmt = 0x22;
    static public final int access_declaration = 0x23;
    static public final int base_type = 0x24;
    static public final int catch_block = 0x25;
    static public final int const_type = 0x26;
    static public final int constant = 0x27;
    static public final int enumerator = 0x28;
    static public final int file_type = 0x29;
    static public final int friend = 0x2a;
    static public final int namelist = 0x2b;
    static public final int namelist_item = 0x2c;
    static public final int packed_type = 0x2d;
    static public final int subprogram = 0x2e;
    static public final int template_type_parameter = 0x2f;
    static public final int template_value_parameter = 0x30;
    static public final int thrown_type = 0x31;
    static public final int try_block = 0x32;
    static public final int variant_part = 0x33;
    static public final int variable = 0x34;
    static public final int volatile_type = 0x35;
    static public final int dwarf_procedure = 0x36;
    static public final int restrict_type = 0x37;
    static public final int interface_type = 0x38;
    static public final int namespace = 0x39;
    static public final int imported_module = 0x3a;
    static public final int unspecified_type = 0x3b;
    static public final int partial_unit = 0x3c;
    static public final int imported_unit = 0x3d;
    static public final int mutable_type = 0x3e;
    static public final int lo_user = 0x4080;
    static public final int hi_user = 0xffff;
  
    static public String toString (long i)
    {
      switch ((int) i) {
      case array_type: return "DW_TAG_array_type";
      case class_type: return "DW_TAG_class_type";
      case entry_point: return "DW_TAG_entry_point";
      case enumeration_type: return "DW_TAG_enumeration_type";
      case formal_parameter: return "DW_TAG_formal_parameter";
      case imported_declaration: return "DW_TAG_imported_declaration";
      case label: return "DW_TAG_label";
      case lexical_block: return "DW_TAG_lexical_block";
      case member: return "DW_TAG_member";
      case pointer_type: return "DW_TAG_pointer_type";
      case reference_type: return "DW_TAG_reference_type";
      case compile_unit: return "DW_TAG_compile_unit";
      case string_type: return "DW_TAG_string_type";
      case structure_type: return "DW_TAG_structure_type";
      case subroutine_type: return "DW_TAG_subroutine_type";
      case typedef: return "DW_TAG_typedef";
      case union_type: return "DW_TAG_union_type";
      case unspecified_parameters: return "DW_TAG_unspecified_parameters";
      case variant: return "DW_TAG_variant";
      case common_block: return "DW_TAG_common_block";
      case common_inclusion: return "DW_TAG_common_inclusion";
      case inheritance: return "DW_TAG_inheritance";
      case inlined_subroutine: return "DW_TAG_inlined_subroutine";
      case module: return "DW_TAG_module";
      case ptr_to_member_type: return "DW_TAG_ptr_to_member_type";
      case set_type: return "DW_TAG_set_type";
      case subrange_type: return "DW_TAG_subrange_type";
      case with_stmt: return "DW_TAG_with_stmt";
      case access_declaration: return "DW_TAG_access_declaration";
      case base_type: return "DW_TAG_base_type";
      case catch_block: return "DW_TAG_catch_block";
      case const_type: return "DW_TAG_const_type";
      case constant: return "DW_TAG_constant";
      case enumerator: return "DW_TAG_enumerator";
      case file_type: return "DW_TAG_file_type";
      case friend: return "DW_TAG_friend";
      case namelist: return "DW_TAG_namelist";
      case namelist_item: return "DW_TAG_namelist_item";
      case packed_type: return "DW_TAG_packed_type";
      case subprogram: return "DW_TAG_subprogram";
      case template_type_parameter: return "DW_TAG_template_type_parameter";
      case template_value_parameter: return "DW_TAG_template_value_parameter";
      case thrown_type: return "DW_TAG_thrown_type";
      case try_block: return "DW_TAG_try_block";
      case variant_part: return "DW_TAG_variant_part";
      case variable: return "DW_TAG_variable";
      case volatile_type: return "DW_TAG_volatile_type";
      case dwarf_procedure: return "DW_TAG_dwarf_procedure";
      case restrict_type: return "DW_TAG_restrict_type";
      case interface_type: return "DW_TAG_interface_type";
      case namespace: return "DW_TAG_namespace";
      case imported_module: return "DW_TAG_imported_module";
      case unspecified_type: return "DW_TAG_unspecified_type";
      case partial_unit: return "DW_TAG_partial_unit";
      case imported_unit: return "DW_TAG_imported_unit";
      case mutable_type: return "DW_TAG_mutable_type";
      case lo_user: return "DW_TAG_lo_user";
      case hi_user: return "DW_TAG_hi_user";
      default: return "DW_TAG_0x" + Long.toHexString (i);
      }
    }
  
    static public String toShortString (long i)
    {
      switch ((int) i) {
      case array_type: return "array_type";
      case class_type: return "class_type";
      case entry_point: return "entry_point";
      case enumeration_type: return "enumeration_type";
      case formal_parameter: return "formal_parameter";
      case imported_declaration: return "imported_declaration";
      case label: return "label";
      case lexical_block: return "lexical_block";
      case member: return "member";
      case pointer_type: return "pointer_type";
      case reference_type: return "reference_type";
      case compile_unit: return "compile_unit";
      case string_type: return "string_type";
      case structure_type: return "structure_type";
      case subroutine_type: return "subroutine_type";
      case typedef: return "typedef";
      case union_type: return "union_type";
      case unspecified_parameters: return "unspecified_parameters";
      case variant: return "variant";
      case common_block: return "common_block";
      case common_inclusion: return "common_inclusion";
      case inheritance: return "inheritance";
      case inlined_subroutine: return "inlined_subroutine";
      case module: return "module";
      case ptr_to_member_type: return "ptr_to_member_type";
      case set_type: return "set_type";
      case subrange_type: return "subrange_type";
      case with_stmt: return "with_stmt";
      case access_declaration: return "access_declaration";
      case base_type: return "base_type";
      case catch_block: return "catch_block";
      case const_type: return "const_type";
      case constant: return "constant";
      case enumerator: return "enumerator";
      case file_type: return "file_type";
      case friend: return "friend";
      case namelist: return "namelist";
      case namelist_item: return "namelist_item";
      case packed_type: return "packed_type";
      case subprogram: return "subprogram";
      case template_type_parameter: return "template_type_parameter";
      case template_value_parameter: return "template_value_parameter";
      case thrown_type: return "thrown_type";
      case try_block: return "try_block";
      case variant_part: return "variant_part";
      case variable: return "variable";
      case volatile_type: return "volatile_type";
      case dwarf_procedure: return "dwarf_procedure";
      case restrict_type: return "restrict_type";
      case interface_type: return "interface_type";
      case namespace: return "namespace";
      case imported_module: return "imported_module";
      case unspecified_type: return "unspecified_type";
      case partial_unit: return "partial_unit";
      case imported_unit: return "imported_unit";
      case mutable_type: return "mutable_type";
      case lo_user: return "lo_user";
      case hi_user: return "hi_user";
      default: return "DW_TAG_0x" + Long.toHexString (i);
      }
    }
  
    static public String toPrintString (long i)
    {
      switch ((int) i) {
      case array_type: return "array type";
      case class_type: return "class type";
      case entry_point: return "entry point";
      case enumeration_type: return "enumeration type";
      case formal_parameter: return "formal parameter";
      case imported_declaration: return "imported declaration";
      case label: return "label";
      case lexical_block: return "lexical block";
      case member: return "member";
      case pointer_type: return "pointer type";
      case reference_type: return "reference type";
      case compile_unit: return "compile unit";
      case string_type: return "string type";
      case structure_type: return "structure type";
      case subroutine_type: return "subroutine type";
      case typedef: return "typedef";
      case union_type: return "union type";
      case unspecified_parameters: return "unspecified parameters";
      case variant: return "variant";
      case common_block: return "common block";
      case common_inclusion: return "common inclusion";
      case inheritance: return "inheritance";
      case inlined_subroutine: return "inlined subroutine";
      case module: return "module";
      case ptr_to_member_type: return "ptr to member type";
      case set_type: return "set type";
      case subrange_type: return "subrange type";
      case with_stmt: return "with stmt";
      case access_declaration: return "access declaration";
      case base_type: return "base type";
      case catch_block: return "catch block";
      case const_type: return "const type";
      case constant: return "constant";
      case enumerator: return "enumerator";
      case file_type: return "file type";
      case friend: return "friend";
      case namelist: return "namelist";
      case namelist_item: return "namelist item";
      case packed_type: return "packed type";
      case subprogram: return "subprogram";
      case template_type_parameter: return "template type parameter";
      case template_value_parameter: return "template value parameter";
      case thrown_type: return "thrown type";
      case try_block: return "try block";
      case variant_part: return "variant part";
      case variable: return "variable";
      case volatile_type: return "volatile type";
      case dwarf_procedure: return "dwarf procedure";
      case restrict_type: return "restrict type";
      case interface_type: return "interface type";
      case namespace: return "namespace";
      case imported_module: return "imported module";
      case unspecified_type: return "unspecified type";
      case partial_unit: return "partial unit";
      case imported_unit: return "imported unit";
      case mutable_type: return "mutable type";
      case lo_user: return "lo user";
      case hi_user: return "hi user";
      default: return "DW_TAG_0x" + Long.toHexString (i);
      }
    }
  
    static public String toPrintString (long i, String def)
    {
      switch ((int) i) {
      case array_type: return "array type";
      case class_type: return "class type";
      case entry_point: return "entry point";
      case enumeration_type: return "enumeration type";
      case formal_parameter: return "formal parameter";
      case imported_declaration: return "imported declaration";
      case label: return "label";
      case lexical_block: return "lexical block";
      case member: return "member";
      case pointer_type: return "pointer type";
      case reference_type: return "reference type";
      case compile_unit: return "compile unit";
      case string_type: return "string type";
      case structure_type: return "structure type";
      case subroutine_type: return "subroutine type";
      case typedef: return "typedef";
      case union_type: return "union type";
      case unspecified_parameters: return "unspecified parameters";
      case variant: return "variant";
      case common_block: return "common block";
      case common_inclusion: return "common inclusion";
      case inheritance: return "inheritance";
      case inlined_subroutine: return "inlined subroutine";
      case module: return "module";
      case ptr_to_member_type: return "ptr to member type";
      case set_type: return "set type";
      case subrange_type: return "subrange type";
      case with_stmt: return "with stmt";
      case access_declaration: return "access declaration";
      case base_type: return "base type";
      case catch_block: return "catch block";
      case const_type: return "const type";
      case constant: return "constant";
      case enumerator: return "enumerator";
      case file_type: return "file type";
      case friend: return "friend";
      case namelist: return "namelist";
      case namelist_item: return "namelist item";
      case packed_type: return "packed type";
      case subprogram: return "subprogram";
      case template_type_parameter: return "template type parameter";
      case template_value_parameter: return "template value parameter";
      case thrown_type: return "thrown type";
      case try_block: return "try block";
      case variant_part: return "variant part";
      case variable: return "variable";
      case volatile_type: return "volatile type";
      case dwarf_procedure: return "dwarf procedure";
      case restrict_type: return "restrict type";
      case interface_type: return "interface type";
      case namespace: return "namespace";
      case imported_module: return "imported module";
      case unspecified_type: return "unspecified type";
      case partial_unit: return "partial unit";
      case imported_unit: return "imported unit";
      case mutable_type: return "mutable type";
      case lo_user: return "lo user";
      case hi_user: return "hi user";
      default: return def;
      }
    }
  }
  public static class CHILDREN
  {
    static public final int no = 0;
    static public final int yes = 1;
  
    static public String toString (long i)
    {
      switch ((int) i) {
      case no: return "DW_CHILDREN_no";
      case yes: return "DW_CHILDREN_yes";
      default: return "DW_CHILDREN_0x" + Long.toHexString (i);
      }
    }
  
    static public String toShortString (long i)
    {
      switch ((int) i) {
      case no: return "no";
      case yes: return "yes";
      default: return "DW_CHILDREN_0x" + Long.toHexString (i);
      }
    }
  
    static public String toPrintString (long i)
    {
      switch ((int) i) {
      case no: return "no";
      case yes: return "yes";
      default: return "DW_CHILDREN_0x" + Long.toHexString (i);
      }
    }
  
    static public String toPrintString (long i, String def)
    {
      switch ((int) i) {
      case no: return "no";
      case yes: return "yes";
      default: return def;
      }
    }
  }
  public static class AT
  {
    static public final int sibling = 0x01;
    static public final int location = 0x02;
    static public final int name = 0x03;
    static public final int ordering = 0x09;
    static public final int byte_size = 0x0b;
    static public final int bit_offset = 0x0c;
    static public final int bit_size = 0x0d;
    static public final int stmt_list = 0x10;
    static public final int low_pc = 0x11;
    static public final int high_pc = 0x12;
    static public final int language = 0x13;
    static public final int discr = 0x15;
    static public final int visibility = 0x17;
    static public final int _import = 0x18;
    static public final int string_length = 0x19;
    static public final int common_reference = 0x1a;
    static public final int comp_dir = 0x1b;
    static public final int const_value = 0x1c;
    static public final int containing_type = 0x1d;
    static public final int default_value = 0x1e;
    static public final int inline = 0x20;
    static public final int is_optional = 0x21;
    static public final int lower_bound = 0x22;
    static public final int producer = 0x25;
    static public final int prototyped = 0x27;
    static public final int return_addr = 0x2a;
    static public final int start_scope = 0x2c;
    static public final int stride_size = 0x2e;
    static public final int upper_bound = 0x2f;
    static public final int abstract_origin = 0x31;
    static public final int accessibility = 0x32;
    static public final int address_class = 0x33;
    static public final int artificial = 0x34;
    static public final int base_types = 0x35;
    static public final int calling_convention = 0x36;
    static public final int count = 0x37;
    static public final int data_member_location = 0x38;
    static public final int decl_column = 0x39;
    static public final int decl_file = 0x3a;
    static public final int decl_line = 0x3b;
    static public final int declaration = 0x3c;
    static public final int discr_list = 0x3d;
    static public final int encoding = 0x3e;
    static public final int external = 0x3f;
    static public final int frame_base = 0x40;
    static public final int friend = 0x41;
    static public final int identifier_case = 0x42;
    static public final int macro_info = 0x43;
    static public final int namelist_item = 0x44;
    static public final int priority = 0x45;
    static public final int segment = 0x46;
    static public final int specification = 0x47;
    static public final int static_link = 0x48;
    static public final int type = 0x49;
    static public final int use_location = 0x4a;
    static public final int variable_parameter = 0x4b;
    static public final int virtuality = 0x4c;
    static public final int vtable_elem_location = 0x4d;
    static public final int allocated = 0x4e;
    static public final int associated = 0x4f;
    static public final int data_location = 0x50;
    static public final int stride = 0x51;
    static public final int entry_pc = 0x52;
    static public final int use_UTF8 = 0x53;
    static public final int extension = 0x54;
    static public final int ranges = 0x55;
    static public final int trampoline = 0x56;
    static public final int call_column = 0x57;
    static public final int call_file = 0x58;
    static public final int call_line = 0x59;
    static public final int description = 0x5a;
    static public final int lo_user = 0x2000;
    static public final int MIPS_linkage_name = 0x2007;
    static public final int hi_user = 0x3fff;
  
    static public String toString (long i)
    {
      switch ((int) i) {
      case sibling: return "DW_AT_sibling";
      case location: return "DW_AT_location";
      case name: return "DW_AT_name";
      case ordering: return "DW_AT_ordering";
      case byte_size: return "DW_AT_byte_size";
      case bit_offset: return "DW_AT_bit_offset";
      case bit_size: return "DW_AT_bit_size";
      case stmt_list: return "DW_AT_stmt_list";
      case low_pc: return "DW_AT_low_pc";
      case high_pc: return "DW_AT_high_pc";
      case language: return "DW_AT_language";
      case discr: return "DW_AT_discr";
      case visibility: return "DW_AT_visibility";
      case _import: return "DW_AT_import";
      case string_length: return "DW_AT_string_length";
      case common_reference: return "DW_AT_common_reference";
      case comp_dir: return "DW_AT_comp_dir";
      case const_value: return "DW_AT_const_value";
      case containing_type: return "DW_AT_containing_type";
      case default_value: return "DW_AT_default_value";
      case inline: return "DW_AT_inline";
      case is_optional: return "DW_AT_is_optional";
      case lower_bound: return "DW_AT_lower_bound";
      case producer: return "DW_AT_producer";
      case prototyped: return "DW_AT_prototyped";
      case return_addr: return "DW_AT_return_addr";
      case start_scope: return "DW_AT_start_scope";
      case stride_size: return "DW_AT_stride_size";
      case upper_bound: return "DW_AT_upper_bound";
      case abstract_origin: return "DW_AT_abstract_origin";
      case accessibility: return "DW_AT_accessibility";
      case address_class: return "DW_AT_address_class";
      case artificial: return "DW_AT_artificial";
      case base_types: return "DW_AT_base_types";
      case calling_convention: return "DW_AT_calling_convention";
      case count: return "DW_AT_count";
      case data_member_location: return "DW_AT_data_member_location";
      case decl_column: return "DW_AT_decl_column";
      case decl_file: return "DW_AT_decl_file";
      case decl_line: return "DW_AT_decl_line";
      case declaration: return "DW_AT_declaration";
      case discr_list: return "DW_AT_discr_list";
      case encoding: return "DW_AT_encoding";
      case external: return "DW_AT_external";
      case frame_base: return "DW_AT_frame_base";
      case friend: return "DW_AT_friend";
      case identifier_case: return "DW_AT_identifier_case";
      case macro_info: return "DW_AT_macro_info";
      case namelist_item: return "DW_AT_namelist_item";
      case priority: return "DW_AT_priority";
      case segment: return "DW_AT_segment";
      case specification: return "DW_AT_specification";
      case static_link: return "DW_AT_static_link";
      case type: return "DW_AT_type";
      case use_location: return "DW_AT_use_location";
      case variable_parameter: return "DW_AT_variable_parameter";
      case virtuality: return "DW_AT_virtuality";
      case vtable_elem_location: return "DW_AT_vtable_elem_location";
      case allocated: return "DW_AT_allocated";
      case associated: return "DW_AT_associated";
      case data_location: return "DW_AT_data_location";
      case stride: return "DW_AT_stride";
      case entry_pc: return "DW_AT_entry_pc";
      case use_UTF8: return "DW_AT_use_UTF8";
      case extension: return "DW_AT_extension";
      case ranges: return "DW_AT_ranges";
      case trampoline: return "DW_AT_trampoline";
      case call_column: return "DW_AT_call_column";
      case call_file: return "DW_AT_call_file";
      case call_line: return "DW_AT_call_line";
      case description: return "DW_AT_description";
      case lo_user: return "DW_AT_lo_user";
      case MIPS_linkage_name: return "DW_AT_MIPS_linkage_name";
      case hi_user: return "DW_AT_hi_user";
      default: return "DW_AT_0x" + Long.toHexString (i);
      }
    }
  
    static public String toShortString (long i)
    {
      switch ((int) i) {
      case sibling: return "sibling";
      case location: return "location";
      case name: return "name";
      case ordering: return "ordering";
      case byte_size: return "byte_size";
      case bit_offset: return "bit_offset";
      case bit_size: return "bit_size";
      case stmt_list: return "stmt_list";
      case low_pc: return "low_pc";
      case high_pc: return "high_pc";
      case language: return "language";
      case discr: return "discr";
      case visibility: return "visibility";
      case _import: return "_import";
      case string_length: return "string_length";
      case common_reference: return "common_reference";
      case comp_dir: return "comp_dir";
      case const_value: return "const_value";
      case containing_type: return "containing_type";
      case default_value: return "default_value";
      case inline: return "inline";
      case is_optional: return "is_optional";
      case lower_bound: return "lower_bound";
      case producer: return "producer";
      case prototyped: return "prototyped";
      case return_addr: return "return_addr";
      case start_scope: return "start_scope";
      case stride_size: return "stride_size";
      case upper_bound: return "upper_bound";
      case abstract_origin: return "abstract_origin";
      case accessibility: return "accessibility";
      case address_class: return "address_class";
      case artificial: return "artificial";
      case base_types: return "base_types";
      case calling_convention: return "calling_convention";
      case count: return "count";
      case data_member_location: return "data_member_location";
      case decl_column: return "decl_column";
      case decl_file: return "decl_file";
      case decl_line: return "decl_line";
      case declaration: return "declaration";
      case discr_list: return "discr_list";
      case encoding: return "encoding";
      case external: return "external";
      case frame_base: return "frame_base";
      case friend: return "friend";
      case identifier_case: return "identifier_case";
      case macro_info: return "macro_info";
      case namelist_item: return "namelist_item";
      case priority: return "priority";
      case segment: return "segment";
      case specification: return "specification";
      case static_link: return "static_link";
      case type: return "type";
      case use_location: return "use_location";
      case variable_parameter: return "variable_parameter";
      case virtuality: return "virtuality";
      case vtable_elem_location: return "vtable_elem_location";
      case allocated: return "allocated";
      case associated: return "associated";
      case data_location: return "data_location";
      case stride: return "stride";
      case entry_pc: return "entry_pc";
      case use_UTF8: return "use_UTF8";
      case extension: return "extension";
      case ranges: return "ranges";
      case trampoline: return "trampoline";
      case call_column: return "call_column";
      case call_file: return "call_file";
      case call_line: return "call_line";
      case description: return "description";
      case lo_user: return "lo_user";
      case MIPS_linkage_name: return "MIPS_linkage_name";
      case hi_user: return "hi_user";
      default: return "DW_AT_0x" + Long.toHexString (i);
      }
    }
  
    static public String toPrintString (long i)
    {
      switch ((int) i) {
      case sibling: return "sibling";
      case location: return "location";
      case name: return "name";
      case ordering: return "ordering";
      case byte_size: return "byte size";
      case bit_offset: return "bit offset";
      case bit_size: return "bit size";
      case stmt_list: return "stmt list";
      case low_pc: return "low pc";
      case high_pc: return "high pc";
      case language: return "language";
      case discr: return "discr";
      case visibility: return "visibility";
      case _import: return "import";
      case string_length: return "string length";
      case common_reference: return "common reference";
      case comp_dir: return "comp dir";
      case const_value: return "const value";
      case containing_type: return "containing type";
      case default_value: return "default value";
      case inline: return "inline";
      case is_optional: return "is optional";
      case lower_bound: return "lower bound";
      case producer: return "producer";
      case prototyped: return "prototyped";
      case return_addr: return "return addr";
      case start_scope: return "start scope";
      case stride_size: return "stride size";
      case upper_bound: return "upper bound";
      case abstract_origin: return "abstract origin";
      case accessibility: return "accessibility";
      case address_class: return "address class";
      case artificial: return "artificial";
      case base_types: return "base types";
      case calling_convention: return "calling convention";
      case count: return "count";
      case data_member_location: return "data member location";
      case decl_column: return "decl column";
      case decl_file: return "decl file";
      case decl_line: return "decl line";
      case declaration: return "declaration";
      case discr_list: return "discr list";
      case encoding: return "encoding";
      case external: return "external";
      case frame_base: return "frame base";
      case friend: return "friend";
      case identifier_case: return "identifier case";
      case macro_info: return "macro info";
      case namelist_item: return "namelist item";
      case priority: return "priority";
      case segment: return "segment";
      case specification: return "specification";
      case static_link: return "static link";
      case type: return "type";
      case use_location: return "use location";
      case variable_parameter: return "variable parameter";
      case virtuality: return "virtuality";
      case vtable_elem_location: return "vtable elem location";
      case allocated: return "allocated";
      case associated: return "associated";
      case data_location: return "data location";
      case stride: return "stride";
      case entry_pc: return "entry pc";
      case use_UTF8: return "use UTF8";
      case extension: return "extension";
      case ranges: return "ranges";
      case trampoline: return "trampoline";
      case call_column: return "call column";
      case call_file: return "call file";
      case call_line: return "call line";
      case description: return "description";
      case lo_user: return "lo user";
      case MIPS_linkage_name: return "MIPS linkage name";
      case hi_user: return "hi user";
      default: return "DW_AT_0x" + Long.toHexString (i);
      }
    }
  
    static public String toPrintString (long i, String def)
    {
      switch ((int) i) {
      case sibling: return "sibling";
      case location: return "location";
      case name: return "name";
      case ordering: return "ordering";
      case byte_size: return "byte size";
      case bit_offset: return "bit offset";
      case bit_size: return "bit size";
      case stmt_list: return "stmt list";
      case low_pc: return "low pc";
      case high_pc: return "high pc";
      case language: return "language";
      case discr: return "discr";
      case visibility: return "visibility";
      case _import: return "import";
      case string_length: return "string length";
      case common_reference: return "common reference";
      case comp_dir: return "comp dir";
      case const_value: return "const value";
      case containing_type: return "containing type";
      case default_value: return "default value";
      case inline: return "inline";
      case is_optional: return "is optional";
      case lower_bound: return "lower bound";
      case producer: return "producer";
      case prototyped: return "prototyped";
      case return_addr: return "return addr";
      case start_scope: return "start scope";
      case stride_size: return "stride size";
      case upper_bound: return "upper bound";
      case abstract_origin: return "abstract origin";
      case accessibility: return "accessibility";
      case address_class: return "address class";
      case artificial: return "artificial";
      case base_types: return "base types";
      case calling_convention: return "calling convention";
      case count: return "count";
      case data_member_location: return "data member location";
      case decl_column: return "decl column";
      case decl_file: return "decl file";
      case decl_line: return "decl line";
      case declaration: return "declaration";
      case discr_list: return "discr list";
      case encoding: return "encoding";
      case external: return "external";
      case frame_base: return "frame base";
      case friend: return "friend";
      case identifier_case: return "identifier case";
      case macro_info: return "macro info";
      case namelist_item: return "namelist item";
      case priority: return "priority";
      case segment: return "segment";
      case specification: return "specification";
      case static_link: return "static link";
      case type: return "type";
      case use_location: return "use location";
      case variable_parameter: return "variable parameter";
      case virtuality: return "virtuality";
      case vtable_elem_location: return "vtable elem location";
      case allocated: return "allocated";
      case associated: return "associated";
      case data_location: return "data location";
      case stride: return "stride";
      case entry_pc: return "entry pc";
      case use_UTF8: return "use UTF8";
      case extension: return "extension";
      case ranges: return "ranges";
      case trampoline: return "trampoline";
      case call_column: return "call column";
      case call_file: return "call file";
      case call_line: return "call line";
      case description: return "description";
      case lo_user: return "lo user";
      case MIPS_linkage_name: return "MIPS linkage name";
      case hi_user: return "hi user";
      default: return def;
      }
    }
  }
  public static class FORM
  {
    static public final int addr = 0x01;
    static public final int block2 = 0x03;
    static public final int block4 = 0x04;
    static public final int data2 = 0x05;
    static public final int data4 = 0x06;
    static public final int data8 = 0x07;
    static public final int string = 0x08;
    static public final int block = 0x09;
    static public final int block1 = 0x0a;
    static public final int data1 = 0x0b;
    static public final int flag = 0x0c;
    static public final int sdata = 0x0d;
    static public final int strp = 0x0e;
    static public final int udata = 0x0f;
    static public final int ref_addr = 0x10;
    static public final int ref1 = 0x11;
    static public final int ref2 = 0x12;
    static public final int ref4 = 0x13;
    static public final int ref8 = 0x14;
    static public final int ref_udata = 0x15;
    static public final int indirect = 0x16;
  
    static public String toString (long i)
    {
      switch ((int) i) {
      case addr: return "DW_FORM_addr";
      case block2: return "DW_FORM_block2";
      case block4: return "DW_FORM_block4";
      case data2: return "DW_FORM_data2";
      case data4: return "DW_FORM_data4";
      case data8: return "DW_FORM_data8";
      case string: return "DW_FORM_string";
      case block: return "DW_FORM_block";
      case block1: return "DW_FORM_block1";
      case data1: return "DW_FORM_data1";
      case flag: return "DW_FORM_flag";
      case sdata: return "DW_FORM_sdata";
      case strp: return "DW_FORM_strp";
      case udata: return "DW_FORM_udata";
      case ref_addr: return "DW_FORM_ref_addr";
      case ref1: return "DW_FORM_ref1";
      case ref2: return "DW_FORM_ref2";
      case ref4: return "DW_FORM_ref4";
      case ref8: return "DW_FORM_ref8";
      case ref_udata: return "DW_FORM_ref_udata";
      case indirect: return "DW_FORM_indirect";
      default: return "DW_FORM_0x" + Long.toHexString (i);
      }
    }
  
    static public String toShortString (long i)
    {
      switch ((int) i) {
      case addr: return "addr";
      case block2: return "block2";
      case block4: return "block4";
      case data2: return "data2";
      case data4: return "data4";
      case data8: return "data8";
      case string: return "string";
      case block: return "block";
      case block1: return "block1";
      case data1: return "data1";
      case flag: return "flag";
      case sdata: return "sdata";
      case strp: return "strp";
      case udata: return "udata";
      case ref_addr: return "ref_addr";
      case ref1: return "ref1";
      case ref2: return "ref2";
      case ref4: return "ref4";
      case ref8: return "ref8";
      case ref_udata: return "ref_udata";
      case indirect: return "indirect";
      default: return "DW_FORM_0x" + Long.toHexString (i);
      }
    }
  
    static public String toPrintString (long i)
    {
      switch ((int) i) {
      case addr: return "addr";
      case block2: return "block2";
      case block4: return "block4";
      case data2: return "data2";
      case data4: return "data4";
      case data8: return "data8";
      case string: return "string";
      case block: return "block";
      case block1: return "block1";
      case data1: return "data1";
      case flag: return "flag";
      case sdata: return "sdata";
      case strp: return "strp";
      case udata: return "udata";
      case ref_addr: return "ref addr";
      case ref1: return "ref1";
      case ref2: return "ref2";
      case ref4: return "ref4";
      case ref8: return "ref8";
      case ref_udata: return "ref udata";
      case indirect: return "indirect";
      default: return "DW_FORM_0x" + Long.toHexString (i);
      }
    }
  
    static public String toPrintString (long i, String def)
    {
      switch ((int) i) {
      case addr: return "addr";
      case block2: return "block2";
      case block4: return "block4";
      case data2: return "data2";
      case data4: return "data4";
      case data8: return "data8";
      case string: return "string";
      case block: return "block";
      case block1: return "block1";
      case data1: return "data1";
      case flag: return "flag";
      case sdata: return "sdata";
      case strp: return "strp";
      case udata: return "udata";
      case ref_addr: return "ref addr";
      case ref1: return "ref1";
      case ref2: return "ref2";
      case ref4: return "ref4";
      case ref8: return "ref8";
      case ref_udata: return "ref udata";
      case indirect: return "indirect";
      default: return def;
      }
    }
  }
  public static class OP
  {
    static public final int addr = 0x03;
    static public final int deref = 0x06;
    static public final int const1u = 0x08;
    static public final int const1s = 0x09;
    static public final int const2s = 0x0b;
    static public final int const4u = 0x0c;
    static public final int const4s = 0x0d;
    static public final int const8u = 0x0e;
    static public final int const8s = 0x0f;
    static public final int constu = 0x10;
    static public final int consts = 0x11;
    static public final int dup = 0x12;
    static public final int drop = 0x13;
    static public final int over = 0x14;
    static public final int pick = 0x15;
    static public final int swap = 0x16;
    static public final int rot = 0x17;
    static public final int xderef = 0x18;
    static public final int abs = 0x19;
    static public final int and = 0x1a;
    static public final int div = 0x1b;
    static public final int minus = 0x1c;
    static public final int mod = 0x1d;
    static public final int mul = 0x1e;
    static public final int neg = 0x1f;
    static public final int not = 0x20;
    static public final int or = 0x21;
    static public final int plus = 0x22;
    static public final int plus_uconst = 0x23;
    static public final int shl = 0x24;
    static public final int shr = 0x25;
    static public final int shra = 0x26;
    static public final int xor = 0x27;
    static public final int skip = 0x2f;
    static public final int bra = 0x28;
    static public final int eq = 0x29;
    static public final int ge = 0x2a;
    static public final int gt = 0x2b;
    static public final int le = 0x2c;
    static public final int lt = 0xed;
    static public final int ne = 0x2e;
    static public final int lit0 = 0x30 + 0;
    static public final int lit1 = 0x30 + 1;
    static public final int lit2 = 0x30 + 2;
    static public final int lit3 = 0x30 + 3;
    static public final int lit4 = 0x30 + 4;
    static public final int lit5 = 0x30 + 5;
    static public final int lit6 = 0x30 + 6;
    static public final int lit7 = 0x30 + 7;
    static public final int lit8 = 0x30 + 8;
    static public final int lit9 = 0x30 + 9;
    static public final int lit10 = 0x30 + 10;
    static public final int lit11 = 0x30 + 11;
    static public final int lit12 = 0x30 + 12;
    static public final int lit13 = 0x30 + 13;
    static public final int lit14 = 0x30 + 14;
    static public final int lit15 = 0x30 + 15;
    static public final int lit16 = 0x30 + 16;
    static public final int lit17 = 0x30 + 17;
    static public final int lit18 = 0x30 + 18;
    static public final int lit19 = 0x30 + 19;
    static public final int lit20 = 0x30 + 20;
    static public final int lit21 = 0x30 + 21;
    static public final int lit22 = 0x30 + 22;
    static public final int lit23 = 0x30 + 23;
    static public final int lit24 = 0x30 + 24;
    static public final int lit25 = 0x30 + 25;
    static public final int lit26 = 0x30 + 26;
    static public final int lit27 = 0x30 + 27;
    static public final int lit28 = 0x30 + 28;
    static public final int lit29 = 0x30 + 29;
    static public final int lit30 = 0x30 + 30;
    static public final int lit31 = 0x30 + 31;
    static public final int reg0 = 0x50 + 0;
    static public final int reg1 = 0x50 + 1;
    static public final int reg2 = 0x50 + 2;
    static public final int reg3 = 0x50 + 3;
    static public final int reg4 = 0x50 + 4;
    static public final int reg5 = 0x50 + 5;
    static public final int reg6 = 0x50 + 6;
    static public final int reg7 = 0x50 + 7;
    static public final int reg8 = 0x50 + 8;
    static public final int reg9 = 0x50 + 9;
    static public final int reg10 = 0x50 + 10;
    static public final int reg11 = 0x50 + 11;
    static public final int reg12 = 0x50 + 12;
    static public final int reg13 = 0x50 + 13;
    static public final int reg14 = 0x50 + 14;
    static public final int reg15 = 0x50 + 15;
    static public final int reg16 = 0x50 + 16;
    static public final int reg17 = 0x50 + 17;
    static public final int reg18 = 0x50 + 18;
    static public final int reg19 = 0x50 + 19;
    static public final int reg20 = 0x50 + 20;
    static public final int reg21 = 0x50 + 21;
    static public final int reg22 = 0x50 + 22;
    static public final int reg23 = 0x50 + 23;
    static public final int reg24 = 0x50 + 24;
    static public final int reg25 = 0x50 + 25;
    static public final int reg26 = 0x50 + 26;
    static public final int reg27 = 0x50 + 27;
    static public final int reg28 = 0x50 + 28;
    static public final int reg29 = 0x50 + 29;
    static public final int reg30 = 0x50 + 30;
    static public final int reg31 = 0x50 + 31;
    static public final int breg0 = 0x70 + 0;
    static public final int breg1 = 0x70 + 1;
    static public final int breg2 = 0x70 + 2;
    static public final int breg3 = 0x70 + 3;
    static public final int breg4 = 0x70 + 4;
    static public final int breg5 = 0x70 + 5;
    static public final int breg6 = 0x70 + 6;
    static public final int breg7 = 0x70 + 7;
    static public final int breg8 = 0x70 + 8;
    static public final int breg9 = 0x70 + 9;
    static public final int breg10 = 0x70 + 10;
    static public final int breg11 = 0x70 + 11;
    static public final int breg12 = 0x70 + 12;
    static public final int breg13 = 0x70 + 13;
    static public final int breg14 = 0x70 + 14;
    static public final int breg15 = 0x70 + 15;
    static public final int breg16 = 0x70 + 16;
    static public final int breg17 = 0x70 + 17;
    static public final int breg18 = 0x70 + 18;
    static public final int breg19 = 0x70 + 19;
    static public final int breg20 = 0x70 + 20;
    static public final int breg21 = 0x70 + 21;
    static public final int breg22 = 0x70 + 22;
    static public final int breg23 = 0x70 + 23;
    static public final int breg24 = 0x70 + 24;
    static public final int breg25 = 0x70 + 25;
    static public final int breg26 = 0x70 + 26;
    static public final int breg27 = 0x70 + 27;
    static public final int breg28 = 0x70 + 28;
    static public final int breg29 = 0x70 + 29;
    static public final int breg30 = 0x70 + 30;
    static public final int breg31 = 0x70 + 31;
    static public final int regx = 0x90;
    static public final int fbreg = 0x91;
    static public final int bregx = 0x92;
    static public final int piece = 0x93;
    static public final int deref_size = 0x94;
    static public final int xdref_size = 0x95;
    static public final int nop = 0x96;
    static public final int push_object_address = 0x97;
    static public final int call2 = 0x98;
    static public final int call4 = 0x99;
    static public final int call_ref = 0x9a;
    static public final int lo_user = 0xc0;
    static public final int hi_user = 0xff;
  
    static public String toString (long i)
    {
      switch ((int) i) {
      case addr: return "DW_OP_addr";
      case deref: return "DW_OP_deref";
      case const1u: return "DW_OP_const1u";
      case const1s: return "DW_OP_const1s";
      case const2s: return "DW_OP_const2s";
      case const4u: return "DW_OP_const4u";
      case const4s: return "DW_OP_const4s";
      case const8u: return "DW_OP_const8u";
      case const8s: return "DW_OP_const8s";
      case constu: return "DW_OP_constu";
      case consts: return "DW_OP_consts";
      case dup: return "DW_OP_dup";
      case drop: return "DW_OP_drop";
      case over: return "DW_OP_over";
      case pick: return "DW_OP_pick";
      case swap: return "DW_OP_swap";
      case rot: return "DW_OP_rot";
      case xderef: return "DW_OP_xderef";
      case abs: return "DW_OP_abs";
      case and: return "DW_OP_and";
      case div: return "DW_OP_div";
      case minus: return "DW_OP_minus";
      case mod: return "DW_OP_mod";
      case mul: return "DW_OP_mul";
      case neg: return "DW_OP_neg";
      case not: return "DW_OP_not";
      case or: return "DW_OP_or";
      case plus: return "DW_OP_plus";
      case plus_uconst: return "DW_OP_plus_uconst";
      case shl: return "DW_OP_shl";
      case shr: return "DW_OP_shr";
      case shra: return "DW_OP_shra";
      case xor: return "DW_OP_xor";
      case skip: return "DW_OP_skip";
      case bra: return "DW_OP_bra";
      case eq: return "DW_OP_eq";
      case ge: return "DW_OP_ge";
      case gt: return "DW_OP_gt";
      case le: return "DW_OP_le";
      case lt: return "DW_OP_lt";
      case ne: return "DW_OP_ne";
      case lit0: return "DW_OP_lit0";
      case lit1: return "DW_OP_lit1";
      case lit2: return "DW_OP_lit2";
      case lit3: return "DW_OP_lit3";
      case lit4: return "DW_OP_lit4";
      case lit5: return "DW_OP_lit5";
      case lit6: return "DW_OP_lit6";
      case lit7: return "DW_OP_lit7";
      case lit8: return "DW_OP_lit8";
      case lit9: return "DW_OP_lit9";
      case lit10: return "DW_OP_lit10";
      case lit11: return "DW_OP_lit11";
      case lit12: return "DW_OP_lit12";
      case lit13: return "DW_OP_lit13";
      case lit14: return "DW_OP_lit14";
      case lit15: return "DW_OP_lit15";
      case lit16: return "DW_OP_lit16";
      case lit17: return "DW_OP_lit17";
      case lit18: return "DW_OP_lit18";
      case lit19: return "DW_OP_lit19";
      case lit20: return "DW_OP_lit20";
      case lit21: return "DW_OP_lit21";
      case lit22: return "DW_OP_lit22";
      case lit23: return "DW_OP_lit23";
      case lit24: return "DW_OP_lit24";
      case lit25: return "DW_OP_lit25";
      case lit26: return "DW_OP_lit26";
      case lit27: return "DW_OP_lit27";
      case lit28: return "DW_OP_lit28";
      case lit29: return "DW_OP_lit29";
      case lit30: return "DW_OP_lit30";
      case lit31: return "DW_OP_lit31";
      case reg0: return "DW_OP_reg0";
      case reg1: return "DW_OP_reg1";
      case reg2: return "DW_OP_reg2";
      case reg3: return "DW_OP_reg3";
      case reg4: return "DW_OP_reg4";
      case reg5: return "DW_OP_reg5";
      case reg6: return "DW_OP_reg6";
      case reg7: return "DW_OP_reg7";
      case reg8: return "DW_OP_reg8";
      case reg9: return "DW_OP_reg9";
      case reg10: return "DW_OP_reg10";
      case reg11: return "DW_OP_reg11";
      case reg12: return "DW_OP_reg12";
      case reg13: return "DW_OP_reg13";
      case reg14: return "DW_OP_reg14";
      case reg15: return "DW_OP_reg15";
      case reg16: return "DW_OP_reg16";
      case reg17: return "DW_OP_reg17";
      case reg18: return "DW_OP_reg18";
      case reg19: return "DW_OP_reg19";
      case reg20: return "DW_OP_reg20";
      case reg21: return "DW_OP_reg21";
      case reg22: return "DW_OP_reg22";
      case reg23: return "DW_OP_reg23";
      case reg24: return "DW_OP_reg24";
      case reg25: return "DW_OP_reg25";
      case reg26: return "DW_OP_reg26";
      case reg27: return "DW_OP_reg27";
      case reg28: return "DW_OP_reg28";
      case reg29: return "DW_OP_reg29";
      case reg30: return "DW_OP_reg30";
      case reg31: return "DW_OP_reg31";
      case breg0: return "DW_OP_breg0";
      case breg1: return "DW_OP_breg1";
      case breg2: return "DW_OP_breg2";
      case breg3: return "DW_OP_breg3";
      case breg4: return "DW_OP_breg4";
      case breg5: return "DW_OP_breg5";
      case breg6: return "DW_OP_breg6";
      case breg7: return "DW_OP_breg7";
      case breg8: return "DW_OP_breg8";
      case breg9: return "DW_OP_breg9";
      case breg10: return "DW_OP_breg10";
      case breg11: return "DW_OP_breg11";
      case breg12: return "DW_OP_breg12";
      case breg13: return "DW_OP_breg13";
      case breg14: return "DW_OP_breg14";
      case breg15: return "DW_OP_breg15";
      case breg16: return "DW_OP_breg16";
      case breg17: return "DW_OP_breg17";
      case breg18: return "DW_OP_breg18";
      case breg19: return "DW_OP_breg19";
      case breg20: return "DW_OP_breg20";
      case breg21: return "DW_OP_breg21";
      case breg22: return "DW_OP_breg22";
      case breg23: return "DW_OP_breg23";
      case breg24: return "DW_OP_breg24";
      case breg25: return "DW_OP_breg25";
      case breg26: return "DW_OP_breg26";
      case breg27: return "DW_OP_breg27";
      case breg28: return "DW_OP_breg28";
      case breg29: return "DW_OP_breg29";
      case breg30: return "DW_OP_breg30";
      case breg31: return "DW_OP_breg31";
      case regx: return "DW_OP_regx";
      case fbreg: return "DW_OP_fbreg";
      case bregx: return "DW_OP_bregx";
      case piece: return "DW_OP_piece";
      case deref_size: return "DW_OP_deref_size";
      case xdref_size: return "DW_OP_xdref_size";
      case nop: return "DW_OP_nop";
      case push_object_address: return "DW_OP_push_object_address";
      case call2: return "DW_OP_call2";
      case call4: return "DW_OP_call4";
      case call_ref: return "DW_OP_call_ref";
      case lo_user: return "DW_OP_lo_user";
      case hi_user: return "DW_OP_hi_user";
      default: return "DW_OP_0x" + Long.toHexString (i);
      }
    }
  
    static public String toShortString (long i)
    {
      switch ((int) i) {
      case addr: return "addr";
      case deref: return "deref";
      case const1u: return "const1u";
      case const1s: return "const1s";
      case const2s: return "const2s";
      case const4u: return "const4u";
      case const4s: return "const4s";
      case const8u: return "const8u";
      case const8s: return "const8s";
      case constu: return "constu";
      case consts: return "consts";
      case dup: return "dup";
      case drop: return "drop";
      case over: return "over";
      case pick: return "pick";
      case swap: return "swap";
      case rot: return "rot";
      case xderef: return "xderef";
      case abs: return "abs";
      case and: return "and";
      case div: return "div";
      case minus: return "minus";
      case mod: return "mod";
      case mul: return "mul";
      case neg: return "neg";
      case not: return "not";
      case or: return "or";
      case plus: return "plus";
      case plus_uconst: return "plus_uconst";
      case shl: return "shl";
      case shr: return "shr";
      case shra: return "shra";
      case xor: return "xor";
      case skip: return "skip";
      case bra: return "bra";
      case eq: return "eq";
      case ge: return "ge";
      case gt: return "gt";
      case le: return "le";
      case lt: return "lt";
      case ne: return "ne";
      case lit0: return "lit0";
      case lit1: return "lit1";
      case lit2: return "lit2";
      case lit3: return "lit3";
      case lit4: return "lit4";
      case lit5: return "lit5";
      case lit6: return "lit6";
      case lit7: return "lit7";
      case lit8: return "lit8";
      case lit9: return "lit9";
      case lit10: return "lit10";
      case lit11: return "lit11";
      case lit12: return "lit12";
      case lit13: return "lit13";
      case lit14: return "lit14";
      case lit15: return "lit15";
      case lit16: return "lit16";
      case lit17: return "lit17";
      case lit18: return "lit18";
      case lit19: return "lit19";
      case lit20: return "lit20";
      case lit21: return "lit21";
      case lit22: return "lit22";
      case lit23: return "lit23";
      case lit24: return "lit24";
      case lit25: return "lit25";
      case lit26: return "lit26";
      case lit27: return "lit27";
      case lit28: return "lit28";
      case lit29: return "lit29";
      case lit30: return "lit30";
      case lit31: return "lit31";
      case reg0: return "reg0";
      case reg1: return "reg1";
      case reg2: return "reg2";
      case reg3: return "reg3";
      case reg4: return "reg4";
      case reg5: return "reg5";
      case reg6: return "reg6";
      case reg7: return "reg7";
      case reg8: return "reg8";
      case reg9: return "reg9";
      case reg10: return "reg10";
      case reg11: return "reg11";
      case reg12: return "reg12";
      case reg13: return "reg13";
      case reg14: return "reg14";
      case reg15: return "reg15";
      case reg16: return "reg16";
      case reg17: return "reg17";
      case reg18: return "reg18";
      case reg19: return "reg19";
      case reg20: return "reg20";
      case reg21: return "reg21";
      case reg22: return "reg22";
      case reg23: return "reg23";
      case reg24: return "reg24";
      case reg25: return "reg25";
      case reg26: return "reg26";
      case reg27: return "reg27";
      case reg28: return "reg28";
      case reg29: return "reg29";
      case reg30: return "reg30";
      case reg31: return "reg31";
      case breg0: return "breg0";
      case breg1: return "breg1";
      case breg2: return "breg2";
      case breg3: return "breg3";
      case breg4: return "breg4";
      case breg5: return "breg5";
      case breg6: return "breg6";
      case breg7: return "breg7";
      case breg8: return "breg8";
      case breg9: return "breg9";
      case breg10: return "breg10";
      case breg11: return "breg11";
      case breg12: return "breg12";
      case breg13: return "breg13";
      case breg14: return "breg14";
      case breg15: return "breg15";
      case breg16: return "breg16";
      case breg17: return "breg17";
      case breg18: return "breg18";
      case breg19: return "breg19";
      case breg20: return "breg20";
      case breg21: return "breg21";
      case breg22: return "breg22";
      case breg23: return "breg23";
      case breg24: return "breg24";
      case breg25: return "breg25";
      case breg26: return "breg26";
      case breg27: return "breg27";
      case breg28: return "breg28";
      case breg29: return "breg29";
      case breg30: return "breg30";
      case breg31: return "breg31";
      case regx: return "regx";
      case fbreg: return "fbreg";
      case bregx: return "bregx";
      case piece: return "piece";
      case deref_size: return "deref_size";
      case xdref_size: return "xdref_size";
      case nop: return "nop";
      case push_object_address: return "push_object_address";
      case call2: return "call2";
      case call4: return "call4";
      case call_ref: return "call_ref";
      case lo_user: return "lo_user";
      case hi_user: return "hi_user";
      default: return "DW_OP_0x" + Long.toHexString (i);
      }
    }
  
    static public String toPrintString (long i)
    {
      switch ((int) i) {
      case addr: return "addr";
      case deref: return "deref";
      case const1u: return "const1u";
      case const1s: return "const1s";
      case const2s: return "const2s";
      case const4u: return "const4u";
      case const4s: return "const4s";
      case const8u: return "const8u";
      case const8s: return "const8s";
      case constu: return "constu";
      case consts: return "consts";
      case dup: return "dup";
      case drop: return "drop";
      case over: return "over";
      case pick: return "pick";
      case swap: return "swap";
      case rot: return "rot";
      case xderef: return "xderef";
      case abs: return "abs";
      case and: return "and";
      case div: return "div";
      case minus: return "minus";
      case mod: return "mod";
      case mul: return "mul";
      case neg: return "neg";
      case not: return "not";
      case or: return "or";
      case plus: return "plus";
      case plus_uconst: return "plus uconst";
      case shl: return "shl";
      case shr: return "shr";
      case shra: return "shra";
      case xor: return "xor";
      case skip: return "skip";
      case bra: return "bra";
      case eq: return "eq";
      case ge: return "ge";
      case gt: return "gt";
      case le: return "le";
      case lt: return "lt";
      case ne: return "ne";
      case lit0: return "lit0";
      case lit1: return "lit1";
      case lit2: return "lit2";
      case lit3: return "lit3";
      case lit4: return "lit4";
      case lit5: return "lit5";
      case lit6: return "lit6";
      case lit7: return "lit7";
      case lit8: return "lit8";
      case lit9: return "lit9";
      case lit10: return "lit10";
      case lit11: return "lit11";
      case lit12: return "lit12";
      case lit13: return "lit13";
      case lit14: return "lit14";
      case lit15: return "lit15";
      case lit16: return "lit16";
      case lit17: return "lit17";
      case lit18: return "lit18";
      case lit19: return "lit19";
      case lit20: return "lit20";
      case lit21: return "lit21";
      case lit22: return "lit22";
      case lit23: return "lit23";
      case lit24: return "lit24";
      case lit25: return "lit25";
      case lit26: return "lit26";
      case lit27: return "lit27";
      case lit28: return "lit28";
      case lit29: return "lit29";
      case lit30: return "lit30";
      case lit31: return "lit31";
      case reg0: return "reg0";
      case reg1: return "reg1";
      case reg2: return "reg2";
      case reg3: return "reg3";
      case reg4: return "reg4";
      case reg5: return "reg5";
      case reg6: return "reg6";
      case reg7: return "reg7";
      case reg8: return "reg8";
      case reg9: return "reg9";
      case reg10: return "reg10";
      case reg11: return "reg11";
      case reg12: return "reg12";
      case reg13: return "reg13";
      case reg14: return "reg14";
      case reg15: return "reg15";
      case reg16: return "reg16";
      case reg17: return "reg17";
      case reg18: return "reg18";
      case reg19: return "reg19";
      case reg20: return "reg20";
      case reg21: return "reg21";
      case reg22: return "reg22";
      case reg23: return "reg23";
      case reg24: return "reg24";
      case reg25: return "reg25";
      case reg26: return "reg26";
      case reg27: return "reg27";
      case reg28: return "reg28";
      case reg29: return "reg29";
      case reg30: return "reg30";
      case reg31: return "reg31";
      case breg0: return "breg0";
      case breg1: return "breg1";
      case breg2: return "breg2";
      case breg3: return "breg3";
      case breg4: return "breg4";
      case breg5: return "breg5";
      case breg6: return "breg6";
      case breg7: return "breg7";
      case breg8: return "breg8";
      case breg9: return "breg9";
      case breg10: return "breg10";
      case breg11: return "breg11";
      case breg12: return "breg12";
      case breg13: return "breg13";
      case breg14: return "breg14";
      case breg15: return "breg15";
      case breg16: return "breg16";
      case breg17: return "breg17";
      case breg18: return "breg18";
      case breg19: return "breg19";
      case breg20: return "breg20";
      case breg21: return "breg21";
      case breg22: return "breg22";
      case breg23: return "breg23";
      case breg24: return "breg24";
      case breg25: return "breg25";
      case breg26: return "breg26";
      case breg27: return "breg27";
      case breg28: return "breg28";
      case breg29: return "breg29";
      case breg30: return "breg30";
      case breg31: return "breg31";
      case regx: return "regx";
      case fbreg: return "fbreg";
      case bregx: return "bregx";
      case piece: return "piece";
      case deref_size: return "deref size";
      case xdref_size: return "xdref size";
      case nop: return "nop";
      case push_object_address: return "push object address";
      case call2: return "call2";
      case call4: return "call4";
      case call_ref: return "call ref";
      case lo_user: return "lo user";
      case hi_user: return "hi user";
      default: return "DW_OP_0x" + Long.toHexString (i);
      }
    }
  
    static public String toPrintString (long i, String def)
    {
      switch ((int) i) {
      case addr: return "addr";
      case deref: return "deref";
      case const1u: return "const1u";
      case const1s: return "const1s";
      case const2s: return "const2s";
      case const4u: return "const4u";
      case const4s: return "const4s";
      case const8u: return "const8u";
      case const8s: return "const8s";
      case constu: return "constu";
      case consts: return "consts";
      case dup: return "dup";
      case drop: return "drop";
      case over: return "over";
      case pick: return "pick";
      case swap: return "swap";
      case rot: return "rot";
      case xderef: return "xderef";
      case abs: return "abs";
      case and: return "and";
      case div: return "div";
      case minus: return "minus";
      case mod: return "mod";
      case mul: return "mul";
      case neg: return "neg";
      case not: return "not";
      case or: return "or";
      case plus: return "plus";
      case plus_uconst: return "plus uconst";
      case shl: return "shl";
      case shr: return "shr";
      case shra: return "shra";
      case xor: return "xor";
      case skip: return "skip";
      case bra: return "bra";
      case eq: return "eq";
      case ge: return "ge";
      case gt: return "gt";
      case le: return "le";
      case lt: return "lt";
      case ne: return "ne";
      case lit0: return "lit0";
      case lit1: return "lit1";
      case lit2: return "lit2";
      case lit3: return "lit3";
      case lit4: return "lit4";
      case lit5: return "lit5";
      case lit6: return "lit6";
      case lit7: return "lit7";
      case lit8: return "lit8";
      case lit9: return "lit9";
      case lit10: return "lit10";
      case lit11: return "lit11";
      case lit12: return "lit12";
      case lit13: return "lit13";
      case lit14: return "lit14";
      case lit15: return "lit15";
      case lit16: return "lit16";
      case lit17: return "lit17";
      case lit18: return "lit18";
      case lit19: return "lit19";
      case lit20: return "lit20";
      case lit21: return "lit21";
      case lit22: return "lit22";
      case lit23: return "lit23";
      case lit24: return "lit24";
      case lit25: return "lit25";
      case lit26: return "lit26";
      case lit27: return "lit27";
      case lit28: return "lit28";
      case lit29: return "lit29";
      case lit30: return "lit30";
      case lit31: return "lit31";
      case reg0: return "reg0";
      case reg1: return "reg1";
      case reg2: return "reg2";
      case reg3: return "reg3";
      case reg4: return "reg4";
      case reg5: return "reg5";
      case reg6: return "reg6";
      case reg7: return "reg7";
      case reg8: return "reg8";
      case reg9: return "reg9";
      case reg10: return "reg10";
      case reg11: return "reg11";
      case reg12: return "reg12";
      case reg13: return "reg13";
      case reg14: return "reg14";
      case reg15: return "reg15";
      case reg16: return "reg16";
      case reg17: return "reg17";
      case reg18: return "reg18";
      case reg19: return "reg19";
      case reg20: return "reg20";
      case reg21: return "reg21";
      case reg22: return "reg22";
      case reg23: return "reg23";
      case reg24: return "reg24";
      case reg25: return "reg25";
      case reg26: return "reg26";
      case reg27: return "reg27";
      case reg28: return "reg28";
      case reg29: return "reg29";
      case reg30: return "reg30";
      case reg31: return "reg31";
      case breg0: return "breg0";
      case breg1: return "breg1";
      case breg2: return "breg2";
      case breg3: return "breg3";
      case breg4: return "breg4";
      case breg5: return "breg5";
      case breg6: return "breg6";
      case breg7: return "breg7";
      case breg8: return "breg8";
      case breg9: return "breg9";
      case breg10: return "breg10";
      case breg11: return "breg11";
      case breg12: return "breg12";
      case breg13: return "breg13";
      case breg14: return "breg14";
      case breg15: return "breg15";
      case breg16: return "breg16";
      case breg17: return "breg17";
      case breg18: return "breg18";
      case breg19: return "breg19";
      case breg20: return "breg20";
      case breg21: return "breg21";
      case breg22: return "breg22";
      case breg23: return "breg23";
      case breg24: return "breg24";
      case breg25: return "breg25";
      case breg26: return "breg26";
      case breg27: return "breg27";
      case breg28: return "breg28";
      case breg29: return "breg29";
      case breg30: return "breg30";
      case breg31: return "breg31";
      case regx: return "regx";
      case fbreg: return "fbreg";
      case bregx: return "bregx";
      case piece: return "piece";
      case deref_size: return "deref size";
      case xdref_size: return "xdref size";
      case nop: return "nop";
      case push_object_address: return "push object address";
      case call2: return "call2";
      case call4: return "call4";
      case call_ref: return "call ref";
      case lo_user: return "lo user";
      case hi_user: return "hi user";
      default: return def;
      }
    }
  }
  public static class ATE
  {
    static public final int addr = 0x01;
    static public final int _boolean = 0x02;
    static public final int complex_float = 0x03;
    static public final int _float = 0x4;
    static public final int signed = 0x5;
    static public final int signed_char = 0x6;
    static public final int unsigned = 0x7;
    static public final int unsigned_char = 0x8;
    static public final int imaginary_float = 0x9;
    static public final int lo_user = 0x80;
    static public final int hi_user = 0xff;
  
    static public String toString (long i)
    {
      switch ((int) i) {
      case addr: return "DW_ATE_addr";
      case _boolean: return "DW_ATE_boolean";
      case complex_float: return "DW_ATE_complex_float";
      case _float: return "DW_ATE_float";
      case signed: return "DW_ATE_signed";
      case signed_char: return "DW_ATE_signed_char";
      case unsigned: return "DW_ATE_unsigned";
      case unsigned_char: return "DW_ATE_unsigned_char";
      case imaginary_float: return "DW_ATE_imaginary_float";
      case lo_user: return "DW_ATE_lo_user";
      case hi_user: return "DW_ATE_hi_user";
      default: return "DW_ATE_0x" + Long.toHexString (i);
      }
    }
  
    static public String toShortString (long i)
    {
      switch ((int) i) {
      case addr: return "addr";
      case _boolean: return "_boolean";
      case complex_float: return "complex_float";
      case _float: return "_float";
      case signed: return "signed";
      case signed_char: return "signed_char";
      case unsigned: return "unsigned";
      case unsigned_char: return "unsigned_char";
      case imaginary_float: return "imaginary_float";
      case lo_user: return "lo_user";
      case hi_user: return "hi_user";
      default: return "DW_ATE_0x" + Long.toHexString (i);
      }
    }
  
    static public String toPrintString (long i)
    {
      switch ((int) i) {
      case addr: return "addr";
      case _boolean: return "boolean";
      case complex_float: return "complex float";
      case _float: return "float";
      case signed: return "signed";
      case signed_char: return "signed char";
      case unsigned: return "unsigned";
      case unsigned_char: return "unsigned char";
      case imaginary_float: return "imaginary float";
      case lo_user: return "lo user";
      case hi_user: return "hi user";
      default: return "DW_ATE_0x" + Long.toHexString (i);
      }
    }
  
    static public String toPrintString (long i, String def)
    {
      switch ((int) i) {
      case addr: return "addr";
      case _boolean: return "boolean";
      case complex_float: return "complex float";
      case _float: return "float";
      case signed: return "signed";
      case signed_char: return "signed char";
      case unsigned: return "unsigned";
      case unsigned_char: return "unsigned char";
      case imaginary_float: return "imaginary float";
      case lo_user: return "lo user";
      case hi_user: return "hi user";
      default: return def;
      }
    }
  }
  public static class ACCESS
  {
    static public final int _public = 1;
    static public final int _protected = 2;
    static public final int _private = 3;
  
    static public String toString (long i)
    {
      switch ((int) i) {
      case _public: return "DW_ACCESS_public";
      case _protected: return "DW_ACCESS_protected";
      case _private: return "DW_ACCESS_private";
      default: return "DW_ACCESS_0x" + Long.toHexString (i);
      }
    }
  
    static public String toShortString (long i)
    {
      switch ((int) i) {
      case _public: return "_public";
      case _protected: return "_protected";
      case _private: return "_private";
      default: return "DW_ACCESS_0x" + Long.toHexString (i);
      }
    }
  
    static public String toPrintString (long i)
    {
      switch ((int) i) {
      case _public: return "public";
      case _protected: return "protected";
      case _private: return "private";
      default: return "DW_ACCESS_0x" + Long.toHexString (i);
      }
    }
  
    static public String toPrintString (long i, String def)
    {
      switch ((int) i) {
      case _public: return "public";
      case _protected: return "protected";
      case _private: return "private";
      default: return def;
      }
    }
  }
  public static class VIS
  {
    static public final int local = 1;
    static public final int exported = 2;
    static public final int qualified = 3;
  
    static public String toString (long i)
    {
      switch ((int) i) {
      case local: return "DW_VIS_local";
      case exported: return "DW_VIS_exported";
      case qualified: return "DW_VIS_qualified";
      default: return "DW_VIS_0x" + Long.toHexString (i);
      }
    }
  
    static public String toShortString (long i)
    {
      switch ((int) i) {
      case local: return "local";
      case exported: return "exported";
      case qualified: return "qualified";
      default: return "DW_VIS_0x" + Long.toHexString (i);
      }
    }
  
    static public String toPrintString (long i)
    {
      switch ((int) i) {
      case local: return "local";
      case exported: return "exported";
      case qualified: return "qualified";
      default: return "DW_VIS_0x" + Long.toHexString (i);
      }
    }
  
    static public String toPrintString (long i, String def)
    {
      switch ((int) i) {
      case local: return "local";
      case exported: return "exported";
      case qualified: return "qualified";
      default: return def;
      }
    }
  }
  public static class VIRTUALITY
  {
    static public final int none = 0;
    static public final int virtual = 1;
    static public final int pure_virtual = 2;
  
    static public String toString (long i)
    {
      switch ((int) i) {
      case none: return "DW_VIRTUALITY_none";
      case virtual: return "DW_VIRTUALITY_virtual";
      case pure_virtual: return "DW_VIRTUALITY_pure_virtual";
      default: return "DW_VIRTUALITY_0x" + Long.toHexString (i);
      }
    }
  
    static public String toShortString (long i)
    {
      switch ((int) i) {
      case none: return "none";
      case virtual: return "virtual";
      case pure_virtual: return "pure_virtual";
      default: return "DW_VIRTUALITY_0x" + Long.toHexString (i);
      }
    }
  
    static public String toPrintString (long i)
    {
      switch ((int) i) {
      case none: return "none";
      case virtual: return "virtual";
      case pure_virtual: return "pure virtual";
      default: return "DW_VIRTUALITY_0x" + Long.toHexString (i);
      }
    }
  
    static public String toPrintString (long i, String def)
    {
      switch ((int) i) {
      case none: return "none";
      case virtual: return "virtual";
      case pure_virtual: return "pure virtual";
      default: return def;
      }
    }
  }
  public static class LANG
  {
    static public final int C89 = 0x0001;
    static public final int C = 0x0002;
    static public final int Ada83 = 0x0003;
    static public final int C_plus_plus = 0x0004;
    static public final int Cobol74 = 0x0005;
    static public final int Cobol85 = 0x0006;
    static public final int Fortran77 = 0x0007;
    static public final int Fortran90 = 0x0008;
    static public final int Pascal83 = 0x0009;
    static public final int Modula2 = 0x000a;
    static public final int Java = 0x000b;
    static public final int C99 = 0x000c;
    static public final int Ada95 = 0x000d;
    static public final int Fortran95 = 0x000e;
    static public final int PL1 = 0x000f;
    static public final int lo_user = 0x8000;
    static public final int hi_user = 0xffff;
  
    static public String toString (long i)
    {
      switch ((int) i) {
      case C89: return "DW_LANG_C89";
      case C: return "DW_LANG_C";
      case Ada83: return "DW_LANG_Ada83";
      case C_plus_plus: return "DW_LANG_C_plus_plus";
      case Cobol74: return "DW_LANG_Cobol74";
      case Cobol85: return "DW_LANG_Cobol85";
      case Fortran77: return "DW_LANG_Fortran77";
      case Fortran90: return "DW_LANG_Fortran90";
      case Pascal83: return "DW_LANG_Pascal83";
      case Modula2: return "DW_LANG_Modula2";
      case Java: return "DW_LANG_Java";
      case C99: return "DW_LANG_C99";
      case Ada95: return "DW_LANG_Ada95";
      case Fortran95: return "DW_LANG_Fortran95";
      case PL1: return "DW_LANG_PL1";
      case lo_user: return "DW_LANG_lo_user";
      case hi_user: return "DW_LANG_hi_user";
      default: return "DW_LANG_0x" + Long.toHexString (i);
      }
    }
  
    static public String toShortString (long i)
    {
      switch ((int) i) {
      case C89: return "C89";
      case C: return "C";
      case Ada83: return "Ada83";
      case C_plus_plus: return "C_plus_plus";
      case Cobol74: return "Cobol74";
      case Cobol85: return "Cobol85";
      case Fortran77: return "Fortran77";
      case Fortran90: return "Fortran90";
      case Pascal83: return "Pascal83";
      case Modula2: return "Modula2";
      case Java: return "Java";
      case C99: return "C99";
      case Ada95: return "Ada95";
      case Fortran95: return "Fortran95";
      case PL1: return "PL1";
      case lo_user: return "lo_user";
      case hi_user: return "hi_user";
      default: return "DW_LANG_0x" + Long.toHexString (i);
      }
    }
  
    static public String toPrintString (long i)
    {
      switch ((int) i) {
      case C89: return "ANSI C";
      case C: return "C";
      case Ada83: return "Ada83";
      case C_plus_plus: return "C++";
      case Cobol74: return "Cobol74";
      case Cobol85: return "Cobol85";
      case Fortran77: return "Fortran77";
      case Fortran90: return "Fortran90";
      case Pascal83: return "Pascal83";
      case Modula2: return "Modula2";
      case Java: return "Unknown: b";
      case C99: return "C99";
      case Ada95: return "Ada95";
      case Fortran95: return "Fortran95";
      case PL1: return "PL1";
      case lo_user: return "lo user";
      case hi_user: return "hi user";
      default: return "DW_LANG_0x" + Long.toHexString (i);
      }
    }
  
    static public String toPrintString (long i, String def)
    {
      switch ((int) i) {
      case C89: return "ANSI C";
      case C: return "C";
      case Ada83: return "Ada83";
      case C_plus_plus: return "C++";
      case Cobol74: return "Cobol74";
      case Cobol85: return "Cobol85";
      case Fortran77: return "Fortran77";
      case Fortran90: return "Fortran90";
      case Pascal83: return "Pascal83";
      case Modula2: return "Modula2";
      case Java: return "Unknown: b";
      case C99: return "C99";
      case Ada95: return "Ada95";
      case Fortran95: return "Fortran95";
      case PL1: return "PL1";
      case lo_user: return "lo user";
      case hi_user: return "hi user";
      default: return def;
      }
    }
  }
  public static class ID
  {
    static public final int case_sensitive = 0;
    static public final int up_case = 1;
    static public final int down_case = 2;
    static public final int case_insensitive = 3;
  
    static public String toString (long i)
    {
      switch ((int) i) {
      case case_sensitive: return "DW_ID_case_sensitive";
      case up_case: return "DW_ID_up_case";
      case down_case: return "DW_ID_down_case";
      case case_insensitive: return "DW_ID_case_insensitive";
      default: return "DW_ID_0x" + Long.toHexString (i);
      }
    }
  
    static public String toShortString (long i)
    {
      switch ((int) i) {
      case case_sensitive: return "case_sensitive";
      case up_case: return "up_case";
      case down_case: return "down_case";
      case case_insensitive: return "case_insensitive";
      default: return "DW_ID_0x" + Long.toHexString (i);
      }
    }
  
    static public String toPrintString (long i)
    {
      switch ((int) i) {
      case case_sensitive: return "case sensitive";
      case up_case: return "up case";
      case down_case: return "down case";
      case case_insensitive: return "case insensitive";
      default: return "DW_ID_0x" + Long.toHexString (i);
      }
    }
  
    static public String toPrintString (long i, String def)
    {
      switch ((int) i) {
      case case_sensitive: return "case sensitive";
      case up_case: return "up case";
      case down_case: return "down case";
      case case_insensitive: return "case insensitive";
      default: return def;
      }
    }
  }
  public static class CC
  {
    static public final int normal = 0x1;
    static public final int program = 0x2;
    static public final int nocall = 0x3;
    static public final int lo_user = 0x40;
    static public final int hi_user = 0xff;
  
    static public String toString (long i)
    {
      switch ((int) i) {
      case normal: return "DW_CC_normal";
      case program: return "DW_CC_program";
      case nocall: return "DW_CC_nocall";
      case lo_user: return "DW_CC_lo_user";
      case hi_user: return "DW_CC_hi_user";
      default: return "DW_CC_0x" + Long.toHexString (i);
      }
    }
  
    static public String toShortString (long i)
    {
      switch ((int) i) {
      case normal: return "normal";
      case program: return "program";
      case nocall: return "nocall";
      case lo_user: return "lo_user";
      case hi_user: return "hi_user";
      default: return "DW_CC_0x" + Long.toHexString (i);
      }
    }
  
    static public String toPrintString (long i)
    {
      switch ((int) i) {
      case normal: return "normal";
      case program: return "program";
      case nocall: return "nocall";
      case lo_user: return "lo user";
      case hi_user: return "hi user";
      default: return "DW_CC_0x" + Long.toHexString (i);
      }
    }
  
    static public String toPrintString (long i, String def)
    {
      switch ((int) i) {
      case normal: return "normal";
      case program: return "program";
      case nocall: return "nocall";
      case lo_user: return "lo user";
      case hi_user: return "hi user";
      default: return def;
      }
    }
  }
  public static class INL
  {
    static public final int not_inlined = 0;
    static public final int inlined = 1;
    static public final int declared_not_inline = 2;
    static public final int declared_inlined = 3;
  
    static public String toString (long i)
    {
      switch ((int) i) {
      case not_inlined: return "DW_INL_not_inlined";
      case inlined: return "DW_INL_inlined";
      case declared_not_inline: return "DW_INL_declared_not_inline";
      case declared_inlined: return "DW_INL_declared_inlined";
      default: return "DW_INL_0x" + Long.toHexString (i);
      }
    }
  
    static public String toShortString (long i)
    {
      switch ((int) i) {
      case not_inlined: return "not_inlined";
      case inlined: return "inlined";
      case declared_not_inline: return "declared_not_inline";
      case declared_inlined: return "declared_inlined";
      default: return "DW_INL_0x" + Long.toHexString (i);
      }
    }
  
    static public String toPrintString (long i)
    {
      switch ((int) i) {
      case not_inlined: return "not inlined";
      case inlined: return "inlined";
      case declared_not_inline: return "declared not inline";
      case declared_inlined: return "declared as inline and inlined";
      default: return "DW_INL_0x" + Long.toHexString (i);
      }
    }
  
    static public String toPrintString (long i, String def)
    {
      switch ((int) i) {
      case not_inlined: return "not inlined";
      case inlined: return "inlined";
      case declared_not_inline: return "declared not inline";
      case declared_inlined: return "declared as inline and inlined";
      default: return def;
      }
    }
  }
  public static class ORD
  {
    static public final int row_major = 0;
    static public final int col_major = 1;
  
    static public String toString (long i)
    {
      switch ((int) i) {
      case row_major: return "DW_ORD_row_major";
      case col_major: return "DW_ORD_col_major";
      default: return "DW_ORD_0x" + Long.toHexString (i);
      }
    }
  
    static public String toShortString (long i)
    {
      switch ((int) i) {
      case row_major: return "row_major";
      case col_major: return "col_major";
      default: return "DW_ORD_0x" + Long.toHexString (i);
      }
    }
  
    static public String toPrintString (long i)
    {
      switch ((int) i) {
      case row_major: return "row major";
      case col_major: return "col major";
      default: return "DW_ORD_0x" + Long.toHexString (i);
      }
    }
  
    static public String toPrintString (long i, String def)
    {
      switch ((int) i) {
      case row_major: return "row major";
      case col_major: return "col major";
      default: return def;
      }
    }
  }
  public static class DSC
  {
    static public final int label = 0;
    static public final int range = 1;
  
    static public String toString (long i)
    {
      switch ((int) i) {
      case label: return "DW_DSC_label";
      case range: return "DW_DSC_range";
      default: return "DW_DSC_0x" + Long.toHexString (i);
      }
    }
  
    static public String toShortString (long i)
    {
      switch ((int) i) {
      case label: return "label";
      case range: return "range";
      default: return "DW_DSC_0x" + Long.toHexString (i);
      }
    }
  
    static public String toPrintString (long i)
    {
      switch ((int) i) {
      case label: return "label";
      case range: return "range";
      default: return "DW_DSC_0x" + Long.toHexString (i);
      }
    }
  
    static public String toPrintString (long i, String def)
    {
      switch ((int) i) {
      case label: return "label";
      case range: return "range";
      default: return def;
      }
    }
  }
  public static class LNS
  {
    static public final int copy = 1;
    static public final int advance_pc = 2;
    static public final int advance_line = 3;
    static public final int set_file = 4;
    static public final int set_column = 5;
    static public final int negate_stmt = 6;
    static public final int set_basic_block = 7;
    static public final int const_add_pc = 8;
    static public final int fixed_advance_pc = 9;
    static public final int set_prologue_end = 10;
    static public final int set_epilogue_begin = 11;
    static public final int set_isa = 12;
  
    static public String toString (long i)
    {
      switch ((int) i) {
      case copy: return "DW_LNS_copy";
      case advance_pc: return "DW_LNS_advance_pc";
      case advance_line: return "DW_LNS_advance_line";
      case set_file: return "DW_LNS_set_file";
      case set_column: return "DW_LNS_set_column";
      case negate_stmt: return "DW_LNS_negate_stmt";
      case set_basic_block: return "DW_LNS_set_basic_block";
      case const_add_pc: return "DW_LNS_const_add_pc";
      case fixed_advance_pc: return "DW_LNS_fixed_advance_pc";
      case set_prologue_end: return "DW_LNS_set_prologue_end";
      case set_epilogue_begin: return "DW_LNS_set_epilogue_begin";
      case set_isa: return "DW_LNS_set_isa";
      default: return "DW_LNS_0x" + Long.toHexString (i);
      }
    }
  
    static public String toShortString (long i)
    {
      switch ((int) i) {
      case copy: return "copy";
      case advance_pc: return "advance_pc";
      case advance_line: return "advance_line";
      case set_file: return "set_file";
      case set_column: return "set_column";
      case negate_stmt: return "negate_stmt";
      case set_basic_block: return "set_basic_block";
      case const_add_pc: return "const_add_pc";
      case fixed_advance_pc: return "fixed_advance_pc";
      case set_prologue_end: return "set_prologue_end";
      case set_epilogue_begin: return "set_epilogue_begin";
      case set_isa: return "set_isa";
      default: return "DW_LNS_0x" + Long.toHexString (i);
      }
    }
  
    static public String toPrintString (long i)
    {
      switch ((int) i) {
      case copy: return "copy";
      case advance_pc: return "advance pc";
      case advance_line: return "advance line";
      case set_file: return "set file";
      case set_column: return "set column";
      case negate_stmt: return "negate stmt";
      case set_basic_block: return "set basic block";
      case const_add_pc: return "const add pc";
      case fixed_advance_pc: return "fixed advance pc";
      case set_prologue_end: return "set prologue end";
      case set_epilogue_begin: return "set epilogue begin";
      case set_isa: return "set isa";
      default: return "DW_LNS_0x" + Long.toHexString (i);
      }
    }
  
    static public String toPrintString (long i, String def)
    {
      switch ((int) i) {
      case copy: return "copy";
      case advance_pc: return "advance pc";
      case advance_line: return "advance line";
      case set_file: return "set file";
      case set_column: return "set column";
      case negate_stmt: return "negate stmt";
      case set_basic_block: return "set basic block";
      case const_add_pc: return "const add pc";
      case fixed_advance_pc: return "fixed advance pc";
      case set_prologue_end: return "set prologue end";
      case set_epilogue_begin: return "set epilogue begin";
      case set_isa: return "set isa";
      default: return def;
      }
    }
  }
  public static class LNE
  {
    static public final int end_sequence = 1;
    static public final int set_address = 2;
    static public final int define_file = 3;
    static public final int lo_user = 128;
    static public final int hi_user = 255;
  
    static public String toString (long i)
    {
      switch ((int) i) {
      case end_sequence: return "DW_LNE_end_sequence";
      case set_address: return "DW_LNE_set_address";
      case define_file: return "DW_LNE_define_file";
      case lo_user: return "DW_LNE_lo_user";
      case hi_user: return "DW_LNE_hi_user";
      default: return "DW_LNE_0x" + Long.toHexString (i);
      }
    }
  
    static public String toShortString (long i)
    {
      switch ((int) i) {
      case end_sequence: return "end_sequence";
      case set_address: return "set_address";
      case define_file: return "define_file";
      case lo_user: return "lo_user";
      case hi_user: return "hi_user";
      default: return "DW_LNE_0x" + Long.toHexString (i);
      }
    }
  
    static public String toPrintString (long i)
    {
      switch ((int) i) {
      case end_sequence: return "end sequence";
      case set_address: return "set address";
      case define_file: return "define file";
      case lo_user: return "lo user";
      case hi_user: return "hi user";
      default: return "DW_LNE_0x" + Long.toHexString (i);
      }
    }
  
    static public String toPrintString (long i, String def)
    {
      switch ((int) i) {
      case end_sequence: return "end sequence";
      case set_address: return "set address";
      case define_file: return "define file";
      case lo_user: return "lo user";
      case hi_user: return "hi user";
      default: return def;
      }
    }
  }
  public static class MACINFO
  {
    static public final int define = 1;
    static public final int undef = 2;
    static public final int start_file = 3;
    static public final int end_file = 4;
    static public final int vendor_ext = 255;
  
    static public String toString (long i)
    {
      switch ((int) i) {
      case define: return "DW_MACINFO_define";
      case undef: return "DW_MACINFO_undef";
      case start_file: return "DW_MACINFO_start_file";
      case end_file: return "DW_MACINFO_end_file";
      case vendor_ext: return "DW_MACINFO_vendor_ext";
      default: return "DW_MACINFO_0x" + Long.toHexString (i);
      }
    }
  
    static public String toShortString (long i)
    {
      switch ((int) i) {
      case define: return "define";
      case undef: return "undef";
      case start_file: return "start_file";
      case end_file: return "end_file";
      case vendor_ext: return "vendor_ext";
      default: return "DW_MACINFO_0x" + Long.toHexString (i);
      }
    }
  
    static public String toPrintString (long i)
    {
      switch ((int) i) {
      case define: return "define";
      case undef: return "undef";
      case start_file: return "start file";
      case end_file: return "end file";
      case vendor_ext: return "vendor ext";
      default: return "DW_MACINFO_0x" + Long.toHexString (i);
      }
    }
  
    static public String toPrintString (long i, String def)
    {
      switch ((int) i) {
      case define: return "define";
      case undef: return "undef";
      case start_file: return "start file";
      case end_file: return "end file";
      case vendor_ext: return "vendor ext";
      default: return def;
      }
    }
  }
  public static class CFA
  {
    static public final int mask = 0xc0;
    static public final int advance_loc = 0x40;
    static public final int offset = 0x80;
    static public final int restore = 0xc0;
    static public final int nop = 0x00;
    static public final int set_loc = 0x01;
    static public final int advance_loc1 = 0x02;
    static public final int advance_loc2 = 0x03;
    static public final int advance_loc4 = 0x04;
    static public final int offset_extended = 0x05;
    static public final int restore_extended = 0x06;
    static public final int undefined = 0x07;
    static public final int same_value = 0x08;
    static public final int register = 0x09;
    static public final int remember_state = 0x0a;
    static public final int restore_state = 0x0b;
    static public final int def_cfa = 0x0c;
    static public final int def_cfa_register = 0x0d;
    static public final int def_cfa_offset = 0x0e;
    static public final int def_cfa_expression = 0x0f;
    static public final int expression = 0x10;
    static public final int offset_extended_sf = 0x11;
    static public final int def_cfa_sf = 0x12;
    static public final int def_cfa_offset_sf = 0x13;
    static public final int GNU_window_save = 0x2d;
    static public final int GNU_args_size = 0x2e;
    static public final int GNU_negative_offset_extended = 0x2f;
    static public final int lo_user = 0x1c;
    static public final int hi_user = 0x3f;
  
    static public String toString (long i)
    {
      if (i != restore && (i & mask) == restore) return "DW_CFA_restore+" + (i & ~mask);
      if (i != offset && (i & mask) == offset) return "DW_CFA_offset+" + (i & ~mask);
      if (i != advance_loc && (i & mask) == advance_loc) return "DW_CFA_advance_loc+" + (i & ~mask);
      switch ((int) i) {
      case advance_loc: return "DW_CFA_advance_loc";
      case offset: return "DW_CFA_offset";
      case restore: return "DW_CFA_restore";
      case nop: return "DW_CFA_nop";
      case set_loc: return "DW_CFA_set_loc";
      case advance_loc1: return "DW_CFA_advance_loc1";
      case advance_loc2: return "DW_CFA_advance_loc2";
      case advance_loc4: return "DW_CFA_advance_loc4";
      case offset_extended: return "DW_CFA_offset_extended";
      case restore_extended: return "DW_CFA_restore_extended";
      case undefined: return "DW_CFA_undefined";
      case same_value: return "DW_CFA_same_value";
      case register: return "DW_CFA_register";
      case remember_state: return "DW_CFA_remember_state";
      case restore_state: return "DW_CFA_restore_state";
      case def_cfa: return "DW_CFA_def_cfa";
      case def_cfa_register: return "DW_CFA_def_cfa_register";
      case def_cfa_offset: return "DW_CFA_def_cfa_offset";
      case def_cfa_expression: return "DW_CFA_def_cfa_expression";
      case expression: return "DW_CFA_expression";
      case offset_extended_sf: return "DW_CFA_offset_extended_sf";
      case def_cfa_sf: return "DW_CFA_def_cfa_sf";
      case def_cfa_offset_sf: return "DW_CFA_def_cfa_offset_sf";
      case GNU_window_save: return "DW_CFA_GNU_window_save";
      case GNU_args_size: return "DW_CFA_GNU_args_size";
      case GNU_negative_offset_extended: return "DW_CFA_GNU_negative_offset_extended";
      case lo_user: return "DW_CFA_lo_user";
      case hi_user: return "DW_CFA_hi_user";
      default: return "DW_CFA_0x" + Long.toHexString (i);
      }
    }
  
    static public String toShortString (long i)
    {
      if (i != restore && (i & mask) == restore) return "restore+" + (i & ~mask);
      if (i != offset && (i & mask) == offset) return "offset+" + (i & ~mask);
      if (i != advance_loc && (i & mask) == advance_loc) return "advance_loc+" + (i & ~mask);
      switch ((int) i) {
      case advance_loc: return "advance_loc";
      case offset: return "offset";
      case restore: return "restore";
      case nop: return "nop";
      case set_loc: return "set_loc";
      case advance_loc1: return "advance_loc1";
      case advance_loc2: return "advance_loc2";
      case advance_loc4: return "advance_loc4";
      case offset_extended: return "offset_extended";
      case restore_extended: return "restore_extended";
      case undefined: return "undefined";
      case same_value: return "same_value";
      case register: return "register";
      case remember_state: return "remember_state";
      case restore_state: return "restore_state";
      case def_cfa: return "def_cfa";
      case def_cfa_register: return "def_cfa_register";
      case def_cfa_offset: return "def_cfa_offset";
      case def_cfa_expression: return "def_cfa_expression";
      case expression: return "expression";
      case offset_extended_sf: return "offset_extended_sf";
      case def_cfa_sf: return "def_cfa_sf";
      case def_cfa_offset_sf: return "def_cfa_offset_sf";
      case GNU_window_save: return "GNU_window_save";
      case GNU_args_size: return "GNU_args_size";
      case GNU_negative_offset_extended: return "GNU_negative_offset_extended";
      case lo_user: return "lo_user";
      case hi_user: return "hi_user";
      default: return "DW_CFA_0x" + Long.toHexString (i);
      }
    }
  
    static public String toPrintString (long i)
    {
      switch ((int) i) {
      case advance_loc: return "advance loc";
      case offset: return "offset";
      case restore: return "restore";
      case nop: return "nop";
      case set_loc: return "set loc";
      case advance_loc1: return "advance loc1";
      case advance_loc2: return "advance loc2";
      case advance_loc4: return "advance loc4";
      case offset_extended: return "offset extended";
      case restore_extended: return "restore extended";
      case undefined: return "undefined";
      case same_value: return "same value";
      case register: return "register";
      case remember_state: return "remember state";
      case restore_state: return "restore state";
      case def_cfa: return "def cfa";
      case def_cfa_register: return "def cfa register";
      case def_cfa_offset: return "def cfa offset";
      case def_cfa_expression: return "def cfa expression";
      case expression: return "expression";
      case offset_extended_sf: return "offset extended sf";
      case def_cfa_sf: return "def cfa sf";
      case def_cfa_offset_sf: return "def cfa offset sf";
      case GNU_window_save: return "GNU window save";
      case GNU_args_size: return "GNU args size";
      case GNU_negative_offset_extended: return "GNU negative offset extended";
      case lo_user: return "lo user";
      case hi_user: return "hi user";
      default: return "DW_CFA_0x" + Long.toHexString (i);
      }
    }
  
    static public String toPrintString (long i, String def)
    {
      switch ((int) i) {
      case advance_loc: return "advance loc";
      case offset: return "offset";
      case restore: return "restore";
      case nop: return "nop";
      case set_loc: return "set loc";
      case advance_loc1: return "advance loc1";
      case advance_loc2: return "advance loc2";
      case advance_loc4: return "advance loc4";
      case offset_extended: return "offset extended";
      case restore_extended: return "restore extended";
      case undefined: return "undefined";
      case same_value: return "same value";
      case register: return "register";
      case remember_state: return "remember state";
      case restore_state: return "restore state";
      case def_cfa: return "def cfa";
      case def_cfa_register: return "def cfa register";
      case def_cfa_offset: return "def cfa offset";
      case def_cfa_expression: return "def cfa expression";
      case expression: return "expression";
      case offset_extended_sf: return "offset extended sf";
      case def_cfa_sf: return "def cfa sf";
      case def_cfa_offset_sf: return "def cfa offset sf";
      case GNU_window_save: return "GNU window save";
      case GNU_args_size: return "GNU args size";
      case GNU_negative_offset_extended: return "GNU negative offset extended";
      case lo_user: return "lo user";
      case hi_user: return "hi user";
      default: return def;
      }
    }
  }

  static public String toString (long i)
  {
    switch ((int) i) {
    default: return "DW_0x" + Long.toHexString (i);
    }
  }

  static public String toShortString (long i)
  {
    switch ((int) i) {
    default: return "DW_0x" + Long.toHexString (i);
    }
  }

  static public String toPrintString (long i)
  {
    switch ((int) i) {
    default: return "DW_0x" + Long.toHexString (i);
    }
  }

  static public String toPrintString (long i, String def)
  {
    switch ((int) i) {
    default: return def;
    }
  }
}
