package inua.elf;

public class SHN
{
  static public final int UNDEF = 0;
  static public final int LORESERVE = 0xff00;
  static public final int LOPROC = 0xff00;
  static public final int HIPROC = 0xff1f;
  static public final int ABS = 0xfff1;
  static public final int COMMON = 0xfff2;
  static public final int HIRESERVE = 0xffff;

  static public String toString (long i)
  {
    switch ((int) i) {
    case UNDEF: return "SHN_UNDEF";
    case ABS: return "SHN_ABS";
    case COMMON: return "SHN_COMMON";
    case HIRESERVE: return "SHN_HIRESERVE";
    default: return "SHN_0x" + Long.toHexString (i);
    }
  }

  static public String toShortString (long i)
  {
    switch ((int) i) {
    case UNDEF: return "UNDEF";
    case ABS: return "ABS";
    case COMMON: return "COMMON";
    case HIRESERVE: return "HIRESERVE";
    default: return "SHN_0x" + Long.toHexString (i);
    }
  }

  static public String toPrintString (long i)
  {
    switch ((int) i) {
    case UNDEF: return "UND";
    case ABS: return "ABS";
    case COMMON: return "COM";
    case HIRESERVE: return "HIRESERVE";
    default: return "SHN_0x" + Long.toHexString (i);
    }
  }

  static public String toPrintString (long i, String def)
  {
    switch ((int) i) {
    case UNDEF: return "UND";
    case ABS: return "ABS";
    case COMMON: return "COM";
    case HIRESERVE: return "HIRESERVE";
    default: return def;
    }
  }
}
