package inua.elf;

public class STT
{
  static public final int NOTYPE = 0;
  static public final int OBJECT = 1;
  static public final int FUNC = 2;
  static public final int SECTION = 3;
  static public final int FILE = 4;
  static public final int COMMON = 5;
  static public final int TLS = 6;
  static public final int LOPROC = 13;
  static public final int HIPROC = 15;

  static public String toString (long i)
  {
    switch ((int) i) {
    case NOTYPE: return "STT_NOTYPE";
    case OBJECT: return "STT_OBJECT";
    case FUNC: return "STT_FUNC";
    case SECTION: return "STT_SECTION";
    case FILE: return "STT_FILE";
    case COMMON: return "STT_COMMON";
    case TLS: return "STT_TLS";
    case LOPROC: return "STT_LOPROC";
    case HIPROC: return "STT_HIPROC";
    default: return "STT_0x" + Long.toHexString (i);
    }
  }

  static public String toShortString (long i)
  {
    switch ((int) i) {
    case NOTYPE: return "NOTYPE";
    case OBJECT: return "OBJECT";
    case FUNC: return "FUNC";
    case SECTION: return "SECTION";
    case FILE: return "FILE";
    case COMMON: return "COMMON";
    case TLS: return "TLS";
    case LOPROC: return "LOPROC";
    case HIPROC: return "HIPROC";
    default: return "STT_0x" + Long.toHexString (i);
    }
  }

  static public String toPrintString (long i)
  {
    switch ((int) i) {
    case NOTYPE: return "NOTYPE";
    case OBJECT: return "OBJECT";
    case FUNC: return "FUNC";
    case SECTION: return "SECTION";
    case FILE: return "FILE";
    case COMMON: return "COMMON";
    case TLS: return "TLS";
    case LOPROC: return "LOPROC";
    case HIPROC: return "HIPROC";
    default: return "STT_0x" + Long.toHexString (i);
    }
  }

  static public String toPrintString (long i, String def)
  {
    switch ((int) i) {
    case NOTYPE: return "NOTYPE";
    case OBJECT: return "OBJECT";
    case FUNC: return "FUNC";
    case SECTION: return "SECTION";
    case FILE: return "FILE";
    case COMMON: return "COMMON";
    case TLS: return "TLS";
    case LOPROC: return "LOPROC";
    case HIPROC: return "HIPROC";
    default: return def;
    }
  }
}
